
ServerEvents.recipes(event => {

    event.shapeless(Item.of('9x minecraft:iron_nugget'), ['minecraft:iron_ingot'])
    event.shapeless(Item.of('minecraft:iron_block'), ['minecraft:iron_ingot','minecraft:iron_ingot','minecraft:iron_ingot','minecraft:iron_ingot','minecraft:iron_ingot','minecraft:iron_ingot','minecraft:iron_ingot','minecraft:iron_ingot','minecraft:iron_ingot'])

    event.recipes.create.pressing('gtceu:compressed_fireclay', 'gtceu:fireclay_dust');
    event.recipes.create.mixing('create:brass_ingot', ['minecraft:copper_ingot', 'create:zinc_ingot']).heatRequirement('lowheated');

    event.campfireCooking('gtceu:wrought_iron_ingot', 'minecraft:iron_ingot');

    event.campfireCooking('minecraft:glass', 'gtceu:glass_dust');

    event.replaceInput({id: 'gtceu:shaped/bronze_primitive_blast_furnace'},
    '#forge:plates/iron',
    'gtceu:wrought_iron_plate'
    );

    event.replaceInput({id: 'gtceu:shaped/bronze_primitive_blast_furnace'},
    '#forge:rods/iron',
    'gtceu:wrought_iron_rod'
    );

    event.replaceInput({id: 'gtceu:shaped/bronze_primitive_blast_furnace'},
    'gtceu:iron_screw',
    'gtceu:wrought_iron_screw'
    );

    event.smelting('minecraft:slime_ball', 'thermal:slime_mushroom_spores');

    event.shaped(Item.of('gtceu:wood_plate'), [
        'SSS'
    ], {
        S: '#minecraft:wooden_slabs'
    });

    event.shaped(Item.of('gtceu:glass_tube'), [
        '   ',
        'PPP',
        'PPP'
    ], {
        P : '#forge:glass_panes'
    });

    event.replaceInput(
        {
            id : 'thermal:device_water_gen'
        },
        'minecraft:copper_ingot',
        '#forge:ingots/lead'
    );
    event.replaceInput(
        {
            id : 'thermal:device_water_gen'
        },
        'minecraft:iron_ingot',
        'minecraft:copper_ingot'
    );
    event.remove({id: 'thermal:redstone_servo'})
    event.shaped(Item.of('thermal:redstone_servo', 1),[
            'RPR',
            ' P ',
            'RPR'
        ], {
            R: 'minecraft:redstone',
            P: '#forge:plates/iron'
        }
    );
    event.shaped(Item.of('thermal:rf_coil'), [
        ' RP',
        'RBR',
        'PR '
    ], {
        R: '#forge:rods/gold',
        P: '#forge:plates/gold',
        B: 'minecraft:redstone_block'
    }); 

    event.recipes.create.mixing('4x thermal:cured_rubber', ['3x thermal:rubber', '#forge:dusts/sulfur']).heatRequirement('lowheated');
    event.recipes.create.pressing('gtceu:rubber_plate', 'thermal:cured_rubber');

    event.recipes.gtceu.fluid_solidifier('gtceu:raw_rubber')
        .inputFluids('thermal:latex 250')
        .itemOutputs('thermal:rubber')
        .duration(120)
        .EUt(8);

    event.recipes.gtceu.macerator('gtceu:blutonium_dust')
        .itemInputs('bigreactors:blutonium_ingot')
        .itemOutputs('bigreactors:blutonium_dust')
        .duration(239)
        .EUt(2);

    event.replaceInput({id: 'mmt:gem/rose_quartz/1'},
        'mmt:rose_quartz',
        'create:rose_quartz'
    );

    event.shapeless(Item.of('minecraft:glowstone'), ['4x minecraft:glowstone_dust']);

    event.shapeless(Item.of('minecraft:redstone_block'), ['9x minecraft:redstone']);

    event.replaceInput({id: 'thermal:device_fisher'}, 
        '#forge:gears/copper',
        '#forge:gears/bronze'
    );

    event.replaceInput({id: 'thermal:device_rock_gen'}, 
        '#forge:gears/constantan',
        '#forge:gears/bronze'
    );

    event.replaceInput({id: 'thermal:device_potion_diffuser'}, 
        '#forge:gears/constantan',
        '#forge:gears/bronze'
    );

    event.recipes.gtceu.assembler('flux_sieve')
        .itemInputs('gtceu:aluminium_frame', '4x gtceu:stainless_steel_plate', 'gtceu:item_filter')
        .itemOutputs('exmachinis:flux_sieve')
        .duration(600)
        .EUt(120);

    event.recipes.gtceu.assembler('gold_upgrade')
        .itemInputs('gtceu:silicon_plate', '#forge:circuits/hv', '16x gtceu:electrum_foil')
        .itemOutputs('exmachinis:gold_upgrade')
        .duration(600)
        .EUt(250);

    event.recipes.gtceu.assembler('diamond_upgrade')
        .itemInputs('gtceu:silicon_plate', '#forge:circuits/ev', '16x gtceu:stainless_steel_foil')
        .itemOutputs('exmachinis:diamond_upgrade')
        .duration(600)
        .EUt(1280);

    event.recipes.gtceu.assembler('netherite_upgrade')
        .itemInputs('gtceu:silicon_plate', '#forge:circuits/hv', '4x minecraft:netherite_ingot')
        .itemOutputs('exmachinis:netherite_upgrade')
        .duration(600)
        .EUt(5200);
    
    event.recipes.gtceu.assembler('flint_mesh')
        .itemInputs('exnihilosequentia:string_mesh', '6x minecraft:flint')
        .itemOutputs('exnihilosequentia:flint_mesh')
        .duration(300)
        .EUt(32);
        
    event.recipes.gtceu.assembler('iron_mesh')
        .itemInputs('exnihilosequentia:flint_mesh', '16x gtceu:wrought_iron_foil')
        .itemOutputs('exnihilosequentia:iron_mesh')
        .duration(300)
        .EUt(128);

    event.recipes.gtceu.assembler('diamond_mesh')
        .itemInputs('exnihilosequentia:iron_mesh', '16x #forge:dusts/diamond')
        .itemOutputs('exnihilosequentia:diamond_mesh')
        .duration(300)
        .EUt(512);

    event.recipes.gtceu.assembler('emerald_mesh')
        .itemInputs('exnihilosequentia:diamond_mesh', '16x #forge:dusts/emerald')
        .itemOutputs('exnihilosequentia:emerald_mesh')
        .duration(300)
        .EUt(1024);

    event.recipes.gtceu.assembler('netherite_mesh')
        .itemInputs('exnihilosequentia:emerald_mesh', '4x minecraft:netherite_ingot')
        .itemOutputs('exnihilosequentia:netherite_mesh')
        .duration(300)
        .EUt(4096);

    event.recipes.gtceu.forge_hammer('gravel_to_sand')
        .itemInputs('minecraft:gravel')
        .itemOutputs('minecraft:sand')
        .duration(10)
        .EUt(16);

    event.recipes.gtceu.forge_hammer('sand_to_dust')
        .itemInputs('minecraft:sand')
        .itemOutputs('exnihilosequentia:dust')
        .duration(10)
        .EUt(16);

    event.recipes.gtceu.macerator('crushed_blackstone')
        .itemInputs('minecraft:blackstone')
        .itemOutputs('exnihilosequentia:crushed_blackstone')
        .duration(10)
        .EUt(8);

    event.recipes.gtceu.extractor('molten_ender')
        .itemInputs('minecraft:ender_pearl')
        .outputFluids('thermal:ender 250')
        .duration(1200)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_soul_infused')
        .itemInputs('#forge:ingots/soul_infused')
        .outputFluids('thermal_extra:soul_infused 144')
        .duration(1200)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_soul_infused_block')
        .itemInputs('#forge:storage_blocks/soul_infused')
        .outputFluids('thermal_extra:soul_infused 1296')
        .duration(9600)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_shellite')
        .itemInputs('#forge:ingots/shellite')
        .outputFluids('thermal_extra:shellite 144')
        .duration(2400)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_shellite_block')
        .itemInputs('#forge:storage_blocks/shellite')
        .outputFluids('thermal_extra:shellite 1296')
        .duration(19200)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_twinite')
        .itemInputs('#forge:ingots/twinite')
        .outputFluids('thermal_extra:twinite 144')
        .duration(4800)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_twinite_block')
        .itemInputs('#forge:storage_blocks/twinite')
        .outputFluids('thermal_extra:twinite 1296')
        .duration(38400)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_dragonsteel')
        .itemInputs('#forge:ingots/dragonsteel')
        .outputFluids('thermal_extra:dragonsteel 144')
        .duration(9600)
        .EUt(32);

    event.recipes.gtceu.extractor('molten_dragonsteel_block')
        .itemInputs('#forge:storage_blocks/dragonsteel')
        .outputFluids('thermal_extra:dragonsteel 1296')
        .duration(76800)
        .EUt(32);

    event.recipes.gtceu.fluid_solidifier('hardened_glass')
        .itemInputs('gtceu:tempered_glass')
        .inputFluids('minecraft:lava 250')
        .itemOutputs('thermal:obsidian_glass')
        .duration(2400)
        .EUt(32);

    event.recipes.gtceu.fluid_solidifier('signalum_glass')
        .itemInputs('gtceu:tempered_glass')
        .inputFluids('gtceu:signalum 144')
        .itemOutputs('thermal:signalum_glass')
        .duration(4800)
        .EUt(32);
        
    event.recipes.gtceu.fluid_solidifier('lumium_glass')
        .itemInputs('gtceu:tempered_glass')
        .inputFluids('gtceu:lumium 144')
        .itemOutputs('thermal:lumium_glass')
        .duration(9600)
        .EUt(32);

    event.recipes.gtceu.fluid_solidifier('enderium_glass')
        .itemInputs('gtceu:tempered_glass')
        .inputFluids('gtceu:enderium 144')
        .itemOutputs('thermal:enderium_glass')
        .duration(19200)
        .EUt(128);

    event.recipes.gtceu.fluid_solidifier('soul_infused_glass')
        .itemInputs('gtceu:laminated_glass')
        .inputFluids('thermal_extra:soul_infused 144')
        .itemOutputs('thermal_extra:soul_infused_glass')
        .duration(38400)
        .EUt(32);

    event.recipes.gtceu.fluid_solidifier('shellite_glass')
        .itemInputs('gtceu:laminated_glass')
        .inputFluids('thermal_extra:shellite 144')
        .itemOutputs('thermal_extra:shellite_glass')
        .duration(76800)
        .EUt(32);

    event.recipes.gtceu.fluid_solidifier('twinite_glass')
        .itemInputs('gtceu:laminated_glass')
        .inputFluids('thermal_extra:twinite 144')
        .itemOutputs('thermal_extra:twinite_glass')
        .duration(153600)
        .EUt(32);

    event.recipes.gtceu.fluid_solidifier('dragonsteel_glass')
        .itemInputs('gtceu:fusion_glass')
        .inputFluids('thermal_extra:dragonsteel 144')
        .itemOutputs('thermal_extra:dragonsteel_glass')
        .duration(307200)
        .EUt(32);

    event.shaped(Item.of('thermal:rf_coil_augment'), [
        ' G ',
        'SCS',
        ' G '
    ], {
        G: '#forge:plates/double/gold',
        S: '#forge:plates/double/silver',
        C: 'thermal:rf_coil'
    });

    event.recipes.gtceu.alloy_smelter('rf_coil_2')
        .itemInputs('thermal:rf_coil_augment', '4x #forge:gears/soul_infused')
        .itemOutputs('thermal_extra:rf_coil_augment_1')
        .duration(2400)
        .EUt(32);

    event.recipes.gtceu.alloy_smelter('rf_coil_3')
        .itemInputs('thermal_extra:rf_coil_augment_1', '4x #forge:gears/enderium')
        .itemOutputs('thermal_extra:rf_coil_augment_2')
        .duration(2400)
        .EUt(128);

    event.recipes.gtceu.alloy_smelter('rf_coil_4')
        .itemInputs('thermal_extra:rf_coil_augment_2', '4x #forge:gears/shellite')
        .itemOutputs('thermal_extra:rf_coil_augment_3')
        .duration(2400)
        .EUt(512);

    event.recipes.gtceu.alloy_smelter('rf_coil_5')
        .itemInputs('thermal_extra:rf_coil_augment_3', '4x #forge:gears/twinite')
        .itemOutputs('thermal_extra:rf_coil_augment_4')
        .duration(2400)
        .EUt(2048);

    event.recipes.gtceu.alloy_smelter('rf_coil_6')
        .itemInputs('thermal_extra:rf_coil_augment_4', '4x #forge:gears/dragonsteel')
        .itemOutputs('thermal_extra:rf_coil_augment_5')
        .duration(2400)
        .EUt(8192);

    event.shaped(Item.of('thermal:rf_coil_storage_augment'), [
        ' S ',
        'GCG',
        ' G '
    ], {
        G: '#forge:plates/double/gold',
        S: '#forge:plates/double/silver',
        C: 'thermal:rf_coil'
    });

    event.recipes.gtceu.alloy_smelter('rf_coil_storage_2')
        .itemInputs('thermal:rf_coil_storage_augment', '4x #forge:gears/soul_infused')
        .itemOutputs('thermal_extra:rf_coil_storage_augment_1')
        .duration(2400)
        .EUt(32);

    event.recipes.gtceu.alloy_smelter('rf_coil_storage_3')
        .itemInputs('thermal_extra:rf_coil_storage_augment_1', '4x #forge:gears/enderium')
        .itemOutputs('thermal_extra:rf_coil_storage_augment_2')
        .duration(2400)
        .EUt(128);

    event.recipes.gtceu.alloy_smelter('rf_coil_storage_4')
        .itemInputs('thermal_extra:rf_coil_storage_augment_2', '4x #forge:gears/shellite')
        .itemOutputs('thermal_extra:rf_coil_storage_augment_3')
        .duration(2400)
        .EUt(512);

    event.recipes.gtceu.alloy_smelter('rf_coil_storage_5')
        .itemInputs('thermal_extra:rf_coil_storage_augment_3', '4x #forge:gears/twinite')
        .itemOutputs('thermal_extra:rf_coil_storage_augment_4')
        .duration(2400)
        .EUt(2048);

    event.recipes.gtceu.alloy_smelter('rf_coil_storage_6')
        .itemInputs('thermal_extra:rf_coil_storage_augment_4', '4x #forge:gears/dragonsteel')
        .itemOutputs('thermal_extra:rf_coil_storage_augment_5')
        .duration(2400)
        .EUt(8192);

    event.shaped(Item.of('thermal:rf_coil_xfer_augment'), [
        ' S ',
        'SCS',
        ' G '
    ], {
        G: '#forge:plates/double/gold',
        S: '#forge:plates/double/silver',
        C: 'thermal:rf_coil'
    });

    event.recipes.gtceu.alloy_smelter('rf_coil_xfer_2')
        .itemInputs('thermal:rf_coil_xfer_augment', '4x #forge:gears/soul_infused')
        .itemOutputs('thermal_extra:rf_coil_xfer_augment_1')
        .duration(2400)
        .EUt(32);

    event.recipes.gtceu.alloy_smelter('rf_coil_xfer_3')
        .itemInputs('thermal_extra:rf_coil_xfer_augment_1', '4x #forge:gears/enderium')
        .itemOutputs('thermal_extra:rf_coil_xfer_augment_2')
        .duration(2400)
        .EUt(128);

    event.recipes.gtceu.alloy_smelter('rf_coil_xfer_4')
        .itemInputs('thermal_extra:rf_coil_xfer_augment_2', '4x #forge:gears/shellite')
        .itemOutputs('thermal_extra:rf_coil_xfer_augment_3')
        .duration(2400)
        .EUt(512);

    event.recipes.gtceu.alloy_smelter('rf_coil_xfer_5')
        .itemInputs('thermal_extra:rf_coil_xfer_augment_3', '4x #forge:gears/twinite')
        .itemOutputs('thermal_extra:rf_coil_xfer_augment_4')
        .duration(2400)
        .EUt(2048);

    event.recipes.gtceu.alloy_smelter('rf_coil_xfer_6')
        .itemInputs('thermal_extra:rf_coil_xfer_augment_4', '4x #forge:gears/dragonsteel')
        .itemOutputs('thermal_extra:rf_coil_xfer_augment_5')
        .duration(2400)
        .EUt(8192);

    event.shaped(Item.of('thermal:fluid_tank_augment'), [
        'RIR',
        'IGI',
        'RIR'
    ], {
        R: '#forge:plates/double/wrought_iron',
        I: 'gtceu:rubber_plate',
        G: 'thermal:obsidian_glass'
    });

    event.recipes.gtceu.alloy_smelter('fluid_tank_2')
        .itemInputs('thermal:fluid_tank_augment', '4x #forge:gears/soul_infused')
        .itemOutputs('thermal_extra:fluid_tank_augment_1')
        .duration(2400)
        .EUt(32);

    event.recipes.gtceu.alloy_smelter('fluid_tank_3')
        .itemInputs('thermal_extra:fluid_tank_augment_1', '4x #forge:gears/enderium')
        .itemOutputs('thermal_extra:fluid_tank_augment_2')
        .duration(2400)
        .EUt(128);

    event.recipes.gtceu.alloy_smelter('fluid_tank_4')
        .itemInputs('thermal_extra:fluid_tank_augment_2', '4x #forge:gears/shellite')
        .itemOutputs('thermal_extra:fluid_tank_augment_3')
        .duration(2400)
        .EUt(512);

    event.recipes.gtceu.alloy_smelter('fluid_tank_5')
        .itemInputs('thermal_extra:fluid_tank_augment_3', '4x #forge:gears/twinite')
        .itemOutputs('thermal_extra:fluid_tank_augment_4')
        .duration(2400)
        .EUt(2048);

    event.recipes.gtceu.alloy_smelter('fluid_tank_6')
        .itemInputs('thermal_extra:fluid_tank_augment_4', '4x #forge:gears/dragonsteel')
        .itemOutputs('thermal_extra:fluid_tank_augment_5')
        .duration(2400)
        .EUt(8192);

    event.recipes.gtceu.fluid_solidifier('fluid_tank_7')
        .itemInputs('thermal_extra:fluid_tank_augment_5')
        .inputFluids('thermal_extra:refined_sunflower_oil 1000')
        .itemOutputs('thermal_extra:fluid_tank_augment_6')
        .duration(2400)
        .EUt(8192);

    event.recipes.gtceu.macerator('basalz_powder')
        .itemInputs('thermal:basalz_rod')
        .itemOutputs('4x thermal:basalz_powder')
        .duration(88)
        .EUt(2);

    event.recipes.gtceu.macerator('blizz_powder')
        .itemInputs('thermal:blizz_rod')
        .itemOutputs('4x thermal:blizz_powder')
        .duration(88)
        .EUt(2);

    event.recipes.gtceu.macerator('blitz_powder')
        .itemInputs('thermal:blitz_rod')
        .itemOutputs('4x thermal:blitz_powder')
        .duration(88)
        .EUt(2);

    event.recipes.gtceu.mixer('earth_charge')
        .itemInputs('#forge:dusts/coals', 'minecraft:gunpowder', 'thermal:basalz_powder')
        .itemOutputs('3x thermal:earth_charge')
        .duration(100)
        .EUt(30);

    event.recipes.gtceu.mixer('ice_charge')
        .itemInputs('#forge:dusts/coals', 'minecraft:gunpowder', 'thermal:blizz_powder')
        .itemOutputs('3x thermal:ice_charge')
        .duration(100)
        .EUt(30);

    event.recipes.gtceu.mixer('lightning_charge')
        .itemInputs('#forge:dusts/coals', 'minecraft:gunpowder', 'thermal:blitz_powder')
        .itemOutputs('3x thermal:lightning_charge')
        .duration(100)
        .EUt(30);

    event.recipes.gtceu.mixer('nether_star_essence')
        .itemInputs('16x minecraft:fire_charge', '16x thermal:earth_charge', '16x thermal:ice_charge', '16x thermal:lightning_charge')
        .chancedOutput('mysticalagriculture:nether_star_essence', 1200, 500)
        .duration(7200)
        .EUt(512);

    event.recipes.gtceu.chemical_bath('nether_star_shard')
        .itemInputs('16x mysticalagriculture:nether_star_essence')
        .inputFluids('gtceu:radon 500')
        .itemOutputs('mysticalagradditions:nether_star_shard')
        .duration(14200)
        .EUt(512);

    event.recipes.gtceu.macerator('nether_star_dust')
        .itemInputs('mysticalagradditions:nether_star_shard')
        .itemOutputs('gtceu:nether_star_small_dust')
        .duration(600)
        .EUt(512);

    event.shaped(Item.of('thermal:energy_cell_frame'), [
        'LEL',
        'E E',
        'LEL'
    ], {
        L: '#forge:plates/lead',
        E: '#forge:plates/electrum'
    });

    event.shaped(Item.of('thermal:fluid_cell_frame'), [
        'BTB',
        'TGT',
        'BTB'
    ], {
        B: '#forge:plates/bronze',
        T: '#forge:plates/tin',
        G: '#forge:glass'
    });

    event.shaped(Item.of('thermal:machine_frame'), [
        'SSS',
        'S S',
        'BBB'
    ], {
        S: 'gtceu:stainless_steel_double_plate',
        B: 'gtceu:black_steel_double_plate'
    });

    event.recipes.create.item_application('thermal:fluid_cell', ['thermal:fluid_cell_frame', 'create:fluid_tank']);

    event.recipes.gtceu.alloy_smelter('fluid_cell')
        .itemInputs('thermal:fluid_cell_frame', 'create:fluid_tank')
        .itemOutputs('thermal:fluid_cell')
        .duration(2400)
        .EUt(32);

    event.recipes.create.item_application('thermal:energy_cell', ['thermal:energy_cell_frame', 'minecraft:redstone_block']);

    event.recipes.gtceu.alloy_smelter('energy_cell')
        .itemInputs('thermal:energy_cell_frame', 'minecraft:redstone_block')
        .itemOutputs('thermal:energy_cell')
        .duration(2400)
        .EUt(32);

    event.shaped(Item.of('bigreactors:basic_reactorcasing'), [
        'PPP',
        'PCP',
        'PPP'
    ], {
        P: 'gtceu:black_steel_plate',
        C: 'gtceu:clean_machine_casing'
    });

    event.shaped(Item.of('bigreactors:basic_reactorcontroller'), [
        'CMC',
        'PEP',
        'CPC'
    ], {
        P: 'gtceu:aluminium_double_plate',
        C: 'bigreactors:basic_reactorcasing',
        M: 'gtceu:computer_monitor_cover',
        E: '#forge:circuits/ev'
    });

    event.shaped(Item.of('bigreactors:basic_reactorfuelrod'), [
        'PAP',
        'GLG',
        'PAP'
    ], {
        A: 'gtceu:aluminium_double_plate',
        P: 'gtceu:black_steel_plate',
        G: 'gtceu:tempered_glass',
        L: 'gtceu:lead_small_fluid_pipe'
    });

    event.shaped(Item.of('bigreactors:basic_reactorcontrolrod'), [
        'CLC',
        'PIP',
        'CRC'
    ], {
        P: 'gtceu:black_steel_plate',
        C: 'bigreactors:basic_reactorcasing',
        I: 'gtceu:lv_electric_piston',
        L: '#forge:circuits/lv',
        R: 'gtceu:silver_long_rod'
    });

    event.shaped(Item.of('bigreactors:reprocessorcasing'), [
        'PCP',
        'CTC',
        'PCP'
    ], {
        P: 'gtceu:niobium_nitride_plate',
        T: 'gtceu:stable_machine_casing',
        C: 'bigreactors:cyanite_ingot'
    });

    event.shaped(Item.of('bigreactors:reprocessorcontroller'), [
        'CMC',
        'PEP',
        'CPC'
    ], {
        P: 'gtceu:black_bronze_double_plate',
        C: 'bigreactors:reprocessorcasing',
        M: 'gtceu:computer_monitor_cover',
        E: '#forge:circuits/iv'
    });

    event.replaceInput({output:'bigreactors:reprocessorcollector'},
        'minecraft:netherite_ingot',
        'gtceu:black_bronze_double_plate'
    );

    event.replaceInput({input:'bigreactors:yellorium'},
        'bigreactors:yellorium',
        'gtceu:uranium_ingot'
    );

    event.shaped(Item.of('bigreactors:fluidizercasing'), [
        'PCP',
        'CTC',
        'PCP'
    ], {
        P: 'gtceu:sterling_silver_plate',
        T: 'gtceu:stable_machine_casing',
        C: 'bigreactors:blutonium_ingot'
    });

    event.shaped(Item.of('bigreactors:fluidizercontroller'), [
        'CMC',
        'PEP',
        'CPC'
    ], {
        P: 'gtceu:kanthal_double_plate',
        C: 'bigreactors:fluidizercasing',
        M: 'gtceu:computer_monitor_cover',
        E: '#forge:circuits/iv'
    });

    event.replaceInput({output:'bigreactors:fluidizerfluidinjector'},
        'minecraft:netherite_ingot',
        'gtceu:nichrome_ingot'
    );

    event.shaped(Item.of('bigreactors:basic_turbinecasing'), [
        'PCP',
        'CTC',
        'PCP'
    ], {
        P: 'gtceu:sterling_silver_plate',
        T: 'gtceu:stable_machine_casing',
        C: 'bigreactors:ridiculite_ingot'
    });

    event.shaped(Item.of('bigreactors:basic_turbinecontroller'), [
        'CMC',
        'PEP',
        'CPC'
    ], {
        P: 'gtceu:nichrome_double_plate',
        C: 'bigreactors:basic_turbinecasing',
        M: 'gtceu:computer_monitor_cover',
        E: '#forge:circuits/iv'
    });
    event.shaped(Item.of('bigreactors:reinforced_turbinecasing'), [
        'PCP',
        'CTC',
        'PCP'
    ], {
        P: 'gtceu:naquadah_plate',
        T: 'gtceu:sturdy_machine_casing',
        C: 'bigreactors:inanite_ingot'
    });

    event.shaped(Item.of('bigreactors:reinforced_turbinecontroller'), [
        'CMC',
        'PEP',
        'CPC'
    ], {
        P: 'gtceu:hssg_double_plate',
        C: 'bigreactors:reinforced_turbinecasing',
        M: 'gtceu:computer_monitor_cover',
        E: '#forge:circuits/luv'
    });

    event.recipes.gtceu.large_chemical_reactor('benitoite')
        .itemInputs('gtceu:rutile_dust', 'gtceu:barium_sulfide_dust', '3x gtceu:silicon_dioxide_dust')
        .inputFluids('gtceu:oxygen 3000')
        .itemOutputs('bigreactors:benitoite_crystal')
        .outputFluids('gtceu:sulfur_dioxide 1000')
        .duration(4200)
        .EUt(1024);

    event.shaped(Item.of('bigreactors:reinforced_reactorcasing'), [
        'PPP',
        'PCP',
        'PPP'
    ], {
        P: 'gtceu:tungsten_carbide_plate',
        C: 'gtceu:frostproof_machine_casing'
    });
    
    event.shaped(Item.of('bigreactors:reinforced_reactorcontroller'), [
        'CMC',
        'PEP',
        'CPC'
    ], {
        P: 'gtceu:bismuth_bronze_double_plate',
        C: 'bigreactors:reinforced_reactorcasing',
        M: 'gtceu:computer_monitor_cover',
        E: '#forge:circuits/iv'
    });
    
    event.shaped(Item.of('bigreactors:reinforced_reactorfuelrod'), [
        'PAP',
        'GLG',
        'PAP'
    ], {
        A: 'gtceu:ultimet_double_plate',
        P: 'gtceu:vanadium_gallium_plate',
        G: 'gtceu:laminated_glass',
        L: 'gtceu:niobium_titanium_small_fluid_pipe'
    });
    
    event.shaped(Item.of('bigreactors:reinforced_reactorcontrolrod'), [
        'CLC',
        'PIP',
        'CRC'
    ], {
        P: 'gtceu:niobium_titanium_plate',
        C: 'bigreactors:reinforced_reactorcasing',
        I: 'gtceu:hv_electric_piston',
        L: '#forge:circuits/hv',
        R: 'gtceu:silver_long_rod'
    });

    event.recipes.gtceu.extractor('nether_agglomeration')
        .itemInputs('gtceu:netherrack_dust')
        .itemOutputs('mysticalagriculture:nether_agglomeratio')
        .duration(12000)
        .EUt(128);

    event.recipes.gtceu.extractor('end_agglomeration')
        .itemInputs('gtceu:endstone_dust')
        .itemOutputs('mysticalagriculture:end_agglomeratio')
        .duration(12000)
        .EUt(128);

    event.recipes.gtceu.mixer('nether_air_mix')
        .itemInputs('mysticalagriculture:nether_agglomeratio')
        .inputFluids('gtceu:air 12000')
        .outputFluids('gtceu:nether_air 12000')
        .duration(1200)
        .EUt(256);

    event.recipes.gtceu.mixer('ender_air_mix')
        .itemInputs('mysticalagriculture:end_agglomeratio')
        .inputFluids('gtceu:nether_air 6000')
        .outputFluids('gtceu:ender_air 6000')
        .duration(1200)
        .EUt(256);     

    event.recipes.gtceu.large_chemical_reactor('easy_netherrack')
        .itemInputs('16x minecraft:redstone')
        .inputFluids('minecraft:lava 32000')
        .itemOutputs('32x minecraft:netherrack')
        .duration(2400)
        .EUt(32)
        .circuit(0);

    event.recipes.gtceu.large_chemical_reactor('easy_endstone')
        .itemInputs('16x minecraft:glowstone_dust')
        .inputFluids('minecraft:lava 32000')
        .itemOutputs('32x minecraft:end_stone')
        .duration(2400)
        .EUt(32)
        .circuit(0);

    event.recipes.gtceu.large_chemical_reactor('flux_dust')
        .itemInputs('32x minecraft:redstone_dust')
        .inputFluids('minecraft:lava 64000')
        .itemOutputs('64x fluxnetworks:flux_dust')
        .duration(2400)
        .EUt(1024)
        .circuit(1);

    event.recipes.gtceu.chemical_reactor('inferium_coal')
        .itemInputs('minecraft:coal', 'mysticalagriculture:inferium_essence')
        .itemOutputs('mysticalagradditions:inferium_coal')
        .duration(400)
        .EUt(32);

    event.recipes.gtceu.chemical_reactor('prudentium_coal')
        .itemInputs('mysticalagradditions:inferium_coal', 'mysticalagriculture:prudentium_essence')
        .itemOutputs('mysticalagradditions:prudentium_coal')
        .duration(400)
        .EUt(32);

    event.recipes.gtceu.chemical_reactor('tertium_coal')
        .itemInputs('mysticalagradditions:prudentium_coal', 'mysticalagriculture:tertium_essence')
        .itemOutputs('mysticalagradditions:tertium_coal')
        .duration(400)
        .EUt(128);

    event.recipes.gtceu.chemical_reactor('imperium_coal')
        .itemInputs('mysticalagradditions:tertium_coal', 'mysticalagriculture:imperium_essence')
        .itemOutputs('mysticalagradditions:imperium_coal')
        .duration(400)
        .EUt(128);

    event.recipes.gtceu.chemical_reactor('supremium_coal')
        .itemInputs('mysticalagradditions:imperium_coal', 'mysticalagriculture:supremium_essence')
        .itemOutputs('mysticalagradditions:supremium_coal')
        .duration(400)
        .EUt(512);

    event.recipes.gtceu.chemical_reactor('insanium_coal')
        .itemInputs('mysticalagradditions:supremium_coal', 'mysticalagradditions:insanium_essence')
        .itemOutputs('mysticalagradditions:insanium_coal')
        .duration(400)
        .EUt(512);

    event.remove({input: 'mmt:scrap_clump'});
    event.remove({input: 'minecraft:netherite_scrap'});
    event.remove({output: 'minecraft:netherite_scrap'});
    event.remove({input: 'minecraft:ancient_debris'});
    event.remove({output: 'minecraft:netherite_ingot'});

    event.recipes.gtceu.electric_blast_furnace('netherite')
        .itemInputs('gtceu:debris_dust', 'minecraft:gold_ingot')
        .inputFluids('gtceu:argon 100')
        .itemOutputs('minecraft:netherite_ingot')
        .blastFurnaceTemp(5000)
        .duration(12000)
        .EUt(8192);

    event.recipes.gtceu.centrifuge('debris_dust')
        .itemInputs('gtceu:netherrack_dust')
        .chancedOutput('gtceu:debris_tiny_dust', 200, 500)
        .duration(20)
        .EUt(8192)
        .circuit(1);

    event.recipes.gtceu.large_chemical_reactor('purified_debris_dust')
        .itemInputs('gtceu:debris_dust')
        .inputFluids('gtceu:chlorine_trifluoride 100')
        .itemOutputs('gtceu:purified_debris_dust', '3x gtceu:titanium_trifluoride_tiny_dust')
        .outputFluids('gtceu:sulfur_dichloride 50')
        .chancedOutput('gtceu:purified_debris_small_dust', 2500, 1000)
        .duration(200)
        .EUt(8192);

    event.recipes.gtceu.chemical_bath('pure_netherite')
        .itemInputs('gtceu:purified_debris_dust')
        .inputFluids('gtceu:tetrachloroethylene 100')
        .itemOutputs('gtceu:pure_netherite_dust')
        .duration(300)
        .EUt(32768);

    event.recipes.gtceu.chemical_reactor('blizz_dust')
        .itemInputs('gtceu:cobalt_dust')
        .inputFluids('gtceu:fluorine 1000')
        .itemOutputs('thermal:blizz_powder')
        .duration(200)
        .EUt(7680);

    event.recipes.gtceu.chemical_reactor('blitz_dust')
        .itemInputs('gtceu:platinum_dust')
        .inputFluids('gtceu:deuterium 1000')
        .itemOutputs('thermal:blitz_powder')
        .duration(200)
        .EUt(1920);

    event.recipes.gtceu.chemical_reactor('basalz_dust')
        .itemInputs('gtceu:rhodium_dust')
        .inputFluids('gtceu:helium 1000')
        .itemOutputs('thermal:basalz_powder')
        .duration(200)
        .EUt(480);

    event.recipes.gtceu.mixer('naquadic_netherite')
        .itemInputs('3x gtceu:naquadah_dust', '5x gtceu:pure_netherite_dust', '2x gtceu:caesium_dust', '5x gtceu:cerium_dust')
        .inputFluids('gtceu:fluorine 12000', 'gtceu:oxygen 32000')
        .itemOutputs('59x gtceu:naquadic_netherite_dust')
        .duration(7600)
        .EUt(8196);

    event.recipes.gtceu.mixer('weapon_grade_naquadah')
        .itemInputs('2x gtceu:pure_netherite_dust', '5x gtceu:neutronium_dust')
        .inputFluids('gtceu:naquadria 7000', 'gtceu:fluorine 16000')
        .itemOutputs('30x gtceu:weapon_grade_naquadah_dust')
        .duration(1200)
        .EUt(524288);

    event.recipes.gtceu.chemical_reactor('chlorine_trifluoride')
        .inputFluids('gtceu:chlorine 1000', 'gtceu:fluorine 3000')
        .outputFluids('gtceu:chlorine_trifluoride 1000')
        .duration(800)
        .EUt(32);

    event.recipes.gtceu.chemical_reactor('dichloroethylene')
        .inputFluids('gtceu:ethane 1000', 'gtceu:chlorine 2000')
        .outputFluids('gtceu:dichloroethane 1000', 'gtceu:hydrochloric_acid 2000')
        .duration(200)
        .EUt(168);

    event.recipes.gtceu.chemical_reactor('tetrachloroetylene')
        .inputFluids('gtceu:dichloroethane', 'gtceu:chlorine 6000')
        .outputFluids('gtceu:tetrachloroethylene 1000', 'gtceu:hydrochloric_acid 4000')
        .duration(600)
        .EUt(200);

    event.recipes.create.mixing('4x gtceu:bronze_ingot', ['3x minecraft:copper_ingot', '#forge:ingots/tin']).heatRequirement('lowheated');
    event.recipes.create.mixing('2x gtceu:brass_ingot', ['minecraft:copper_ingot', '#forge:ingots/zinc']).heatRequirement('lowheated');
    

    event.recipes.gtceu.alloy_smelter('rubber_sheet_from_thermal')
        .itemInputs('2x thermal:cured_rubber')
        .notConsumable('gtceu:plate_casting_mold')
        .itemOutputs('gtceu:rubber_plate')
        .duration(10)
        .EUt(7);

    event.recipes.gtceu.extruder('rubber_sheet_from_thermal_extruder')
        .itemInputs('thermal:cured_rubber')
        .notConsumable('gtceu:plate_extruder_mold')
        .itemOutputs('gtceu:rubber_plate')
        .duration(5)
        .EUt(56);

    event.recipes.gtceu.extractor('rubber_fluid_from_thermal')
        .itemInputs('thermal:cured_rubber')
        .outputFluids('gtceu:rubber 144')
        .duration(5)
        .EUt(30);

    event.recipes.gtceu.assembler('boiler_pipe')
        .itemInputs('gtceu:tempered_glass', '3x gtceu:bronze_ring')
        .itemOutputs('systeams:boiler_pipe')
        .duration(120)
        .EUt(128);

    event.shaped(Item.of('4x thermal:energy_duct'), [
        'LRL',
        'LRL',
        'LRL'
    ], {
        L: 'gtceu:lead_plate',
        R: 'minecraft:redstone'
    });

    event.recipes.gtceu.assembler('energy_duct_cheap')
        .itemInputs('6x gtceu:lead_plate', '3x minecraft:redstone')
        .itemOutputs('12x thermal:energy_duct')
        .duration(240)
        .EUt(32);

    event.shaped(Item.of('8x thermal:energy_duct'), [
        'LRL',
        'LRL',
        'LRL'
    ], {
        L: 'gtceu:lead_double_plate',
        R: 'minecraft:redstone'
    });

    event.recipes.gtceu.assembler('energy_duct_cheaper')
        .itemInputs('6x gtceu:lead_double_plate', '3x minecraft:redstone')
        .itemOutputs('24x thermal:energy_duct')
        .duration(240)
        .EUt(128);

    event.recipes.gtceu.assembler('energy_attachement')
        .itemInputs('3x gtceu:electrum_plate', 'minecraft:redstone', '#forge:circuits/lv')
        .itemOutputs('2x thermal:energy_limiter_attachment')
        .duration(320)
        .EUt(128);

    event.recipes.gtceu.assembler('steam_dynamo')
        .itemInputs('gtceu:hv_machine_hull', '#forge:circuits/hv', 'systeams:boiler_pipe', '4x gtceu:cupronickel_double_wire', '4x gtceu:black_steel_plate', 'gtceu:lead_rotor')
        .itemOutputs('systeams:steam_dynamo')
        .duration(640)
        .EUt(512);

    event.recipes.gtceu.centrifuge('graphite_from_coke')
        .itemInputs('16x gtceu:coke_gem')
        .itemOutputs('gtceu:graphite_small_dust')
        .duration(780)
        .EUt(48);

    event.shaped(Item.of('thermal:fluid_duct'), [
        'BPB',
        'BPB',
        'BPB'
    ], {
        B: 'gtceu:bronze_plate',
        P: 'gtceu:bronze_small_fluid_pipe'
    });

    event.shaped(Item.of('thermal:fluid_duct_windowed'), [
        'BPB',
        'GPG',
        'BPB'
    ], {
        B: 'gtceu:bronze_plate',
        G: '#forge:glass_panes',
        P: 'gtceu:bronze_small_fluid_pipe'
    });

    event.shaped(Item.of('16x thermal:servo_attachment'), [
        ' T ',
        'TPT',
        ' T '
    ], {
        T: 'gtceu:tin_plate',
        P: 'gtceu:lv_electric_pump'
    });

    event.recipes.gtceu.assembler('turbo_servo')
        .itemInputs('thermal:servo_attachment', '4x gtceu:aluminium_plate', '#forge:circuits/mv')
        .itemOutputs('4x thermal:turbo_servo_attachment')
        .duration(200)
        .EUt(128);
});